// Copyright (C) 2002 Hewlett-Packard Company
// All rights reserved.
//
/*Declarations for the attribute tables.*/
extern const int FAR_TOKEN mapAttribTagNumToIndex[];

/*Attribute index numbers in an easy to swallow format. These number may be
derived from the omcnATT_ equivalents using the mapAttribTagNumToIndex
table. Note that these numbers are consecutive.*/
#define omcnIDX_SURNAME			0		/* Surname */
#define omcnIDX_GIVEN			1		/* Given Name */
#define omcnIDX_INITIALS		2		/* Initials */
#define omcnIDX_GQ				3		/* Generation Qualifier */
#define omcnIDX_ORG1			4		/* Organisational Unit 1 */
#define omcnIDX_ORG2			5		/* Organisational Unit 2 */
#define omcnIDX_ORG3			6		/* Organisational Unit 3 */
#define omcnIDX_ORG4			7		/* Organisational Unit 4 */
#define omcnIDX_ORGNAME			8		/* Organisation */
#define omcnIDX_COUNTRY			9		/* Country Code */
#define omcnIDX_ADMD			10		/* Administration Domain */
#define omcnIDX_PRMD			11		/* Private Domain */
#define omcnIDX_X121			12		/* X.121 Network Address */
#define omcnIDX_NUM_UID			13		/* Numeric User Identifier */
#define omcnIDX_TERM_UID		14		/* Terminal Identifier */
#define omcnIDX_DDAT1			15		/* DDA Type 1 */
#define omcnIDX_DDAV1			16		/* DDA Value 1 */
#define omcnIDX_DDAT2			17		/* DDA Type 2 */
#define omcnIDX_DDAV2			18		/* DDA Value 2 */
#define omcnIDX_DDAT3			19		/* DDA Type 3 */
#define omcnIDX_DDAV3			20		/* DDA Value 3 */
#define omcnIDX_DDAT4			21		/* DDA Type 4 */
#define omcnIDX_DDAV4			22		/* DDA Value 4 */

#define omcnIDX_COMMON_NAME		23		/* Common Name */
#define omcnIDX_FREE_FORM		24		/* Free form name */

#define omcnIDX_TX_SURNAME		25		/* Teletex Surname */
#define omcnIDX_TX_GIVEN		26		/* Teletex Given Name */
#define omcnIDX_TX_INITIALS		27		/* Teletex Initials */
#define omcnIDX_TX_GQ			28		/* Teletex Generation Qualifier */
#define omcnIDX_TX_ORG1			29		/* Teletex Organisational Unit 1 */
#define omcnIDX_TX_ORG2			30		/* Teletex Organisational Unit 2 */
#define omcnIDX_TX_ORG3			31		/* Teletex Organisational Unit 3 */
#define omcnIDX_TX_ORG4			32		/* Teletex Organisational Unit 4 */
#define omcnIDX_TX_ORGNAME		33		/* Teletex Organisation */
#define omcnIDX_TX_DDAT1		34		/* Teletex DDA Type 1 */
#define omcnIDX_TX_DDAV1		35		/* Teletex DDA Value 1 */
#define omcnIDX_TX_DDAT2		36		/* Teletex DDA Type 2 */
#define omcnIDX_TX_DDAV2		37		/* Teletex DDA Value 2 */
#define omcnIDX_TX_DDAT3		38		/* Teletex DDA Type 3 */
#define omcnIDX_TX_DDAV3		39		/* Teletex DDA Value 3 */
#define omcnIDX_TX_DDAT4		40		/* Teletex DDA Type 4 */
#define omcnIDX_TX_DDAV4		41		/* Teletex DDA Value 4 */

#define omcnIDX_TX_COMMON_NAME	42		/* Teletex Common Name */

/* Internal directory tag numbers in an easy to swallow format. Note that these
numbers are NOT all consecutive.*/
#define omcnATT_SURNAME			1		/* Surname */
#define omcnATT_GIVEN			2		/* Given Name */
#define omcnATT_INITIALS		3		/* Initials */
#define omcnATT_GQ				4		/* Generation Qualifier */
#define omcnATT_ORG1			5		/* Organisational Unit 1 */
#define omcnATT_ORG2			6		/* Organisational Unit 2 */
#define omcnATT_ORG3			7		/* Organisational Unit 3 */
#define omcnATT_ORG4			8		/* Organisational Unit 4 */
#define omcnATT_ORGNAME			9		/* Organisation */
#define omcnATT_COUNTRY			10		/* Country Code */
#define omcnATT_ADMD			11		/* Administration Domain */
#define omcnATT_PRMD			12		/* Private Domain */
#define omcnATT_X121			13		/* X.121 Network Address */
#define omcnATT_NUM_UID			14		/* Numeric User Identifier */
#define omcnATT_TERM_UID		15		/* Terminal Identifier */
#define omcnATT_DDAT1			16		/* DDA Type 1 */
#define omcnATT_DDAV1			17		/* DDA Value 1 */
#define omcnATT_DDAT2			18		/* DDA Type 2 */
#define omcnATT_DDAV2			19		/* DDA Value 2 */
#define omcnATT_DDAT3			20		/* DDA Type 3 */
#define omcnATT_DDAV3			21		/* DDA Value 3 */
#define omcnATT_DDAT4			22		/* DDA Type 4 */
#define omcnATT_DDAV4			23		/* DDA Value 4 */

#define omcnATT_COMMON_NAME		24		/* Common Name */
#define omcnATT_FREE_FORM		25		/* Free form name */

#define omcnATT_NETNUM			26
#define omcnATT_SUBNET			27
#define omcnATT_PSAP			28
#define omcnATT_TERM_TYPE		29
#define omcnATT_PDS_NAME		30
#define omcnATT_PD_COUNTRY		31
#define omcnATT_POSTCODE		32
#define omcnATT_PD_OFFICE_NAME	33
#define omcnATT_PD_OFFICE_NUM	34
#define omcnATT_PD_PERS_NAME	35
#define omcnATT_PD_ORGNAME		36
#define omcnATT_STREET_ADDR		37
#define omcnATT_POBOX_ADDR		38
#define omcnATT_UNIQ_POSTAL_NAME	39
#define omcnATT_LOCAL_POST_ATTRS	40
#define omcnATT_UNF_POST_ADDR_LINE	41
#define omcnATT_POSTE_RESTANTE	42
#define omcnATT_EXT_OR_ADDR		43
#define omcnATT_EXT_PD_ADDR		44

#define omcnATT_TX_SURNAME		51		/* Teletex Surname */
#define omcnATT_TX_GIVEN		52		/* Teletex Given Name */
#define omcnATT_TX_INITIALS		53		/* Teletex Initials */
#define omcnATT_TX_GQ			54		/* Teletex Generation Qualifier */
#define omcnATT_TX_ORG1			55		/* Teletex Organisational Unit 1 */
#define omcnATT_TX_ORG2			56		/* Teletex Organisational Unit 2 */
#define omcnATT_TX_ORG3			57		/* Teletex Organisational Unit 3 */
#define omcnATT_TX_ORG4			58		/* Teletex Organisational Unit 4 */
#define omcnATT_TX_ORGNAME		59		/* Teletex Organisation */
#define omcnATT_TX_DDAT1		60		/* Teletex DDA Type 1 */
#define omcnATT_TX_DDAV1		61		/* Teletex DDA Value 1 */
#define omcnATT_TX_DDAT2		62		/* Teletex DDA Type 2 */
#define omcnATT_TX_DDAV2		63		/* Teletex DDA Value 2 */
#define omcnATT_TX_DDAT3		64		/* Teletex DDA Type 3 */
#define omcnATT_TX_DDAV3		65		/* Teletex DDA Value 3 */
#define omcnATT_TX_DDAT4		66		/* Teletex DDA Type 4 */
#define omcnATT_TX_DDAV4		67		/* Teletex DDA Value 4 */

#define omcnATT_TX_COMMON_NAME	68		/* Teletex Common Name */

#define omcnATT_TX_PD_OFFICE_NAME	70
#define omcnATT_TX_PD_OFFICE_NUM	71
#define omcnATT_TX_PD_PERS_NAME		72
#define omcnATT_TX_PD_ORGNAME		73
#define omcnATT_TX_PD_UNF_POST_ADDR_FULL	74
#define omcnATT_TX_STREET_ADDR		75
#define omcnATT_TX_POBOX_ADDR		76
#define omcnATT_TX_UNIQ_POSTAL_NAME	77
#define omcnATT_TX_LOCAL_POST_ATTRS	78

#define omcnATT_TX_POSTE_RESTANTE	80
#define omcnATT_TX_EXT_OR_ADDR		81
#define omcnATT_TX_EXT_PD_ADDR		82

#define omcnATT_PRIM_PHONE		    116

#define omcnATT_INTERNET_NAME		167

/*Generic attribute types.*/
#define omcnATT_GENERIC_PSTRING     5000
#define omcnATT_GENERIC_NSTRING		5001
#define omcnATT_GENERIC_STRING		5002
#define omcnATT_GENERIC_TELETEX		5003		

/*Mask to obtain all the alternatives.*/
#define omcnALT_MASK_ALL_ALTS		(omcnALT_MASK_NAME_ALTS | \
									 omcnALT_MASK_X400_ALTS | \
									 omcnALT_MASK_USER_ALTS )

/****************************************************************************
Name alternatives.
The following flags describe the various interpretations of names based on the
name type and the number of token sections. Types are CANonical and
NONcanonical. For canonical names, the first token section is always the
surname (everything up to the comma). Token sections after the comma, and
everything in a non-canonical name, are separated by unescaped spaces.
The alternatives are described by how the tokens are allocated:
	Non-canonical - GxIxSxQx token sections for given, inits, surname and gq.
	Canonical     - GxIxQx token sections for given, inits and gq

In non-canonical names, the surname is limited to a maximum of 3 sections.
In both name types, the given name is limited to a maximum of 2 sections.

The alternative flags are set up such that:
	Bits 0-2	The number of token sections in the name
	Bit  3		Set if the name is canonical, unset for non-canonical
	Bits 4-12	Each bit represents a condition to test for
    Bit  15		Set if this is classed as an obscure combination

	Bits 16-31	Used for non-name alternatives

*****************************************************************************/
/*Mask to obtain the alternatives list.*/
#define omcnALT_MASK_NAME_ALTS		0x00007ff0L

/*Non-canonical one token.*/
#define omcnALT_NON_I   0x00000011L
#define omcnALT_NON_S   0x00000021L
#define omcnALT_NON_Q   0x00008041L
#define omcnALT_NON_G	0x00000081L	/* Base assumption */

#define omcnALT_NON_1	0x000000f1L

#define omcnALT_NON_1_1_NOT_I	0x000000e1L	/*1st token not initials.*/

/*Non-canonical two tokens.*/
#define omcnALT_NON_GS  0x00000012L
#define omcnALT_NON_GQ  0x00008022L
#define omcnALT_NON_GG  0x00000042L
#define omcnALT_NON_IS  0x00000082L
#define omcnALT_NON_IQ  0x00008102L
#define omcnALT_NON_SQ  0x00000202L
#define omcnALT_NON_SS  0x00000402L
#define omcnALT_NON_GI	0x00000802L	/* Base assumption */

#define omcnALT_NON_2	0x00000ff2L

#define omcnALT_NON_2_1_NOT_I	0x00000e72L	/*1st token not initials.*/

/*Non-canonical three tokens.*/
#define omcnALT_NON_GSS 0x00000013L
#define omcnALT_NON_GSQ 0x00000023L
#define omcnALT_NON_GIQ 0x00008043L
#define omcnALT_NON_GGI 0x00000083L
#define omcnALT_NON_GGS 0x00000103L
#define omcnALT_NON_GGQ 0x00008203L
#define omcnALT_NON_ISQ 0x00000403L
#define omcnALT_NON_ISS 0x00000803L
#define omcnALT_NON_SSS 0x00001003L
#define omcnALT_NON_SSQ 0x0000a003L
#define omcnALT_NON_GIS	0x00004003L	/* Base assumption */

#define omcnALT_NON_3	0x00007ff3L

#define omcnALT_NON_3_1_NOT_I	0x000073f3L	/*1st token not initials.*/

/*Non-canonical four tokens.*/
#define omcnALT_NON_GISS    0x00000014L
#define omcnALT_NON_GSSS    0x00000024L
#define omcnALT_NON_GSSQ    0x00000044L
#define omcnALT_NON_GGIS    0x00000084L
#define omcnALT_NON_GGIQ    0x00008104L
#define omcnALT_NON_GGSQ    0x00000204L
#define omcnALT_NON_GGSS    0x00000404L
#define omcnALT_NON_ISSQ    0x00000804L
#define omcnALT_NON_ISSS    0x00001004L
#define omcnALT_NON_SSSQ    0x0000a004L
#define omcnALT_NON_GISQ	0x00004004L	/*Base assumption*/

#define omcnALT_NON_4		0x00007ff4L

/*Non-canonical five tokens.*/
#define omcnALT_NON_GISSS   0x00000015L
#define omcnALT_NON_GGISS   0x00000025L
#define omcnALT_NON_GGISQ   0x00000045L
#define omcnALT_NON_GGSSS   0x00000085L
#define omcnALT_NON_GGSSQ   0x00000105L
#define omcnALT_NON_ISSSQ   0x00000205L
#define omcnALT_NON_GISSQ	0x00000405L	/*Base assumption*/

#define omcnALT_NON_5		0x000007f5L

/*Non-canonical six tokens.*/
#define omcnALT_NON_GGISSS  0x00000016L
#define omcnALT_NON_GGISSQ	0x00000026L
#define omcnALT_NON_GGSSSQ  0x00000046L
#define omcnALT_NON_GISSSQ  0x00000086L	/*Base assumption*/

#define omcnALT_NON_6		0x000000f6L

/*Non-canonical seven tokens.*/
#define omcnALT_NON_GGISSSQ	0x00000017L	/*Base assumption*/

#define omcnALT_NON_7		0x00000017L

/*Canonical one token.*/
#define omcnALT_CAN_S       0x00000019L	/*Base assumption*/
#define omcnALT_CAN_S_STRIP	0x00000029L	/*Strip trailing white space.*/

#define omcnALT_CAN_1		0x00000039L

/*Canonical two tokens.*/
#define omcnALT_CAN_SI      0x0000001AL
#define omcnALT_CAN_SQ      0x0000802AL
#define omcnALT_CAN_SG      0x0000004AL	/*Base assumption*/

#define omcnALT_CAN_2		0x0000007aL

/*Canonical three tokens.*/
#define omcnALT_CAN_SGG     0x0000001BL
#define omcnALT_CAN_SGQ     0x0000002BL
#define omcnALT_CAN_SIQ     0x0000004BL
#define omcnALT_CAN_SGI     0x0000008BL	/*Base assumption*/

#define omcnALT_CAN_3		0x000000fbL
#define omcnALT_CAN_3_2_NOT_INIT	(omcnALT_CAN_3 ^ omcnALT_CAN_SIQ)

/*Canonical four tokens.*/
#define omcnALT_CAN_SGGI    0x0000001CL
#define omcnALT_CAN_SGGQ    0x0000002CL
#define omcnALT_CAN_SGIQ    0x0000004CL	/*Base assumption*/

#define omcnALT_CAN_4		0x0000007cL

/*Canonical five tokens.*/
#define omcnALT_CAN_SGGIQ   0x0000001DL	/*Base assumption*/

#define omcnALT_CAN_5		0x0000001DL

/*Mask to determine the number of tokens for the alternative flags.*/
#define omcnALT_MASK_TOK_COUNT		0x00000007L
#define omcnALT_SHIFT_TOK_COUNT		0

/*Mask to determine the name type for the alternative flags.*/
#define omcnALT_MASK_NAME_TYPE		0x00000008L
#define omcnFLAG_CANONICAL_ALT		omcnALT_MASK_NAME_TYPE

/*Mask to determine if the alternative is an obscure combination.*/
#define omcnALT_MASK_NAME_OBSCURE	0x00008000L


/****************************************************************************
 X.400 token alternatives.
 ****************************************************************************/
/*Mask to obtain the alternatives list.*/
#define omcnALT_MASK_X400_ALTS		0x00030000L

#define omcnALT_X400_1ST_IS_TAG		0x00010000L

/****************************************************************************
 User defined token alternatives.
 ****************************************************************************/
/*Mask to obtain the alternatives list.*/
#define omcnALT_MASK_USER_ALTS		0x00300000L

#define omcnALT_USER_BASE			0x00100000L	/*Do not strip white space*/
#define omcnALT_USER_STRIP			0x00200000L	/*Do strip white space*/

#define omcnALT_USER_ALL			0x00300000L
