<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<!--
//////////////////////////////////////////////////////////////////////////////
//  
//  Project
//      Scalix Rules Wizard
//  
//  File
//      .\sclxres\acts.xsl
//  
//  Description
//      
//  
//  Copyright (c) 2004 Scalix Corp. All rights reserved
//  
//  Developed for Scalix Corp. by
//      Equiom, Inc.
//      www.equiom.com
//  
//  History
//      03/07/04    (saedn)
//          created
//  
//////////////////////////////////////////////////////////////////////////////
-->
<xsl:include href="strings.xsl"/>

<xsl:template match="/">
<actions>
  <xsl:apply-templates select="actions"/>
</actions>
</xsl:template>

<xsl:template match="actions"><xsl:apply-templates/></xsl:template>

<xsl:template match="action">
  <xsl:if test="@skip = 0">
    <action>
      <xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
      <xsl:attribute name="eo"><xsl:value-of select="@eo"/></xsl:attribute>
      <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
      <xsl:attribute name="event"><xsl:value-of select="@event"/></xsl:attribute>
      <xsl:attribute name="server"><xsl:value-of select="@server"/></xsl:attribute>
      <xsl:apply-templates/>
    </action>
  </xsl:if>
</xsl:template>


<xsl:template match="title">
  <xsl:choose>
    <xsl:when test="parent::action[@id = 1]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act01_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act01_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 2]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act02_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act02_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 3]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act03_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act03_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 4]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act04_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act04_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 5]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act05_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act05_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 6]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act06_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act06_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 7]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act07_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act07_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 8]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act08_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act08_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 9]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act09_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act09_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 10]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act10_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act10_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 11]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act11_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act11_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 12]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act12_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act12_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 13]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act13_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act13_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 14]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act14_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act14_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 15]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act15_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act15_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 16]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act16_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act16_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 17]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act17_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act17_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 18]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act18_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act18_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
    <xsl:when test="parent::action[@id = 19]">
      <title>
	    <xsl:attribute name="preLink"><xsl:value-of select="$g_Act19_sPreLink"/></xsl:attribute>
        <xsl:attribute name="postLink"><xsl:value-of select="$g_Act19_sPostLink"/></xsl:attribute>
	  </title>
    </xsl:when>
  </xsl:choose>
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="selector">
  <selector>
    <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
    <xsl:attribute name="link">
    <xsl:choose>
      <xsl:when test="parent::action[@id = 1]">
        <xsl:value-of select="$g_Act01_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 2]">
        <xsl:value-of select="$g_Act02_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 5]">
        <xsl:value-of select="$g_Act05_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 6]">
        <xsl:value-of select="$g_Act05_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 8]">
        <xsl:value-of select="$g_Act08_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 9]">
        <xsl:value-of select="$g_Act09_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 10]">
        <xsl:value-of select="$g_Act10_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 12]">
        <xsl:value-of select="$g_Act12_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 13]">
        <xsl:value-of select="$g_Act13_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 14]">
        <xsl:value-of select="$g_Act14_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 15]">
        <xsl:value-of select="$g_Act15_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 16]">
        <xsl:value-of select="$g_Act16_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 17]">
        <xsl:value-of select="$g_Act17_sLink"/>
      </xsl:when>
      <xsl:when test="parent::action[@id = 18]">
        <xsl:value-of select="$g_Act18_sLink"/>
      </xsl:when>
    </xsl:choose>
    </xsl:attribute>
  </selector>
  <xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>
